# Enum Class ImageProcessor.Mode

Object
Enum<ImageProcessor.Mode>
Mode

All Implemented Interfaces:
  `Serializable, Comparable<ImageProcessor​.Mode>, Constable`

Enclosing class:
  `ImageProcessor`

public static enum ImageProcessor.Mode extends Enum<ImageProcessor.Mode>
Execution modes specifying whether operations can be executed in parallel. If `SEQUENTIAL`, operations are executed sequentially in the caller thread. If `PARALLEL`, some operations may be parallelized using an arbitrary number of threads.

Since:
  1.1
See Also:
  - `ImageProcessor​.getExecutionMode()`
  - `ImageProcessor​.setExecutionMode(Mode)`

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum​.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DEFAULT`
  Operations are executed in multi-threaded mode if the `RenderedImage` instance is an implementation known to be thread-safe.
  `PARALLEL`
  Operations executed in multi-threaded mode if possible.
  `SEQUENTIAL`
  Operations executed in the caller thread, without parallelization.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ImageProcessor​.Mode`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ImageProcessor​.Mode[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### PARALLEL

    public static final ImageProcessor.Mode PARALLEL
    Operations executed in multi-threaded mode if possible. This mode can be used if the `RenderedImage` instances are thread-safe and provide a concurrent (or very fast) implementation of `RenderedImage​.getTile(int, int)`.

  - ### SEQUENTIAL

    public static final ImageProcessor.Mode SEQUENTIAL
    Operations executed in the caller thread, without parallelization. Sequential operations may be useful for processing `RenderedImage` implementations that may not be thread-safe.

  - ### DEFAULT

    public static final ImageProcessor.Mode DEFAULT
    Operations are executed in multi-threaded mode if the `RenderedImage` instance is an implementation known to be thread-safe. All operations on image implementations unknown to Apache SIS are executed in sequential mode.

- ## Method Details

  - ### values

    public static ImageProcessor.Mode[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ImageProcessor.Mode valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null